% --------------------------------------------------------------
% Towers of Hanoi
% Viktor Engelmann
% www.AlgorithMan.de
% --------------------------------------------------------------
% this code is provided under the terms of the GNU General
% Public License v3. See gpl3.txt for details
% --------------------------------------------------------------

hanoi(_, _, _, 0).
hanoi(From, To, Intermediate, Count):-
   Count > 0,
   NextCount is Count-1,
   hanoi(From, Intermediate, To, NextCount),
   write('move top disc from peg '),
   write(From),
   write(' to peg '),
   write(To),
   write('\n'),
   hanoi(Intermediate, To, From, NextCount).
   
main:-
   write('How many discs? > '),
   read(A),
   (integer(A)
   ->hanoi(1, 3, 2, A)
   ;write('ERROR: not an integer\n')),
   fail. % make it go to halt clause
main:-halt.
